//
// TinyPTC by Gaffer
// www.gaffer.org/tinyptc
//

#include "tinyptc.h"
#include "math.h"
#include "stdlib.h"
#include "stdio.h"
#include "string.h"


#include "math3d.h"
#include "ymse.h"

#define WIDTH 640
#define HEIGHT 480
#define BYTES_PER_PIXEL 4	// Note: This is hard-coded in several places for speed -- sorry
#define SIZE WIDTH*HEIGHT*BYTES_PER_PIXEL

static unsigned char pixbuffer1[SIZE];
static unsigned char pixbuffer2[SIZE];
//static unsigned char pixbuffer2[SIZE];






int main(int argc, char *argv[])
{
	int index;
//	int direction;
	int cycle1 = 0;
	int cycle2 = 0;
	int cycle3 = 0;
	int cycle4 = 0;
	int cycle5 = 0;
	int cycle6 = 0;
	int cycle7 = 0;

	char scrolltext[4096] = "";
//	char visibletext[40];
//	char firstletter;
	char secondletter;

	// Area calc
	int area;
	int top;
	int bottom;
	int left;
	int right;

	int textscanner;
	int textmajor = 0;
	int textminor = 0;
//	int textwidth;
	int pixel;
	static unsigned char scrollbuf[20*WIDTH*4];	// Used for rendering scroll text
	vertex2d upperleft;
	vertex2d lowerleft;
	vertex2d upperright;
	vertex2d lowerright;
	
	vertex2d *point;
	int resolution = 16;
	int ctrl_points = 5;

//	char debug[255];
	int points_x[4];
	int points_y[4];
	int points;

/*	int p1x;
	int p1y;
	int p2x;
	int p2y;
	int p3x;
	int p3y;
	int radius;*/

	char debug[80];

	int upper_pNx[16];
	int upper_pNy[16];
	int lower_pNx[16];
	int lower_pNy[16];

	math3d_model cube_model;
	math3d_model discos_model;

	math3d_object cube_object1;
	math3d_object cube_object2;
	math3d_object cube_object3;
	math3d_object cube_object4;
	math3d_object cube_object5;
	math3d_object cube_object6;
	math3d_object cube_object7;
	math3d_object cube_object8;
	math3d_object cube_object9;
	math3d_object cube_object10;

	math3d_object discos_object1;
	math3d_object discos_object2;
	math3d_object discos_object3;
	math3d_object discos_object4;
	math3d_object discos_object5;
	math3d_object discos_object6;
	math3d_object discos_object7;
	math3d_object discos_object8;

	char modelname[260];
//	char description[80];

    if (!ptc_open("M3D Viewer",WIDTH,HEIGHT)) return 1;

    buffer = (unsigned int*) pixbuffer1;	// Select output buffer
	width = WIDTH;
	height = HEIGHT;

	load_font("test");
	init_math3d();
	
	//cube_model = load_model3d("cube.m3d");		// A 'blueprint' describing an object
//	cube_model = create_testmodel3d(400);		// A 'blueprint' describing an object
	
	color = WHITE;

	strcat(scrolltext, "                                      ");
	strcat(scrolltext, "  After 16 years, this is our first production written from scratch in pure C/assembler - please go easy on us ;-))");
	strcat(scrolltext, "  We're using the TinyPTC library, this makes it easy to concentrate on the plotting of pixels but difficult to play any music.");
	strcat(scrolltext, "  Code: Floyd  Design: Savuud");
	strcat(scrolltext, "  Thanks to Allman, Treant and Savuud for help with learning C and some tricky math stuff!");
	strcat(scrolltext, "  Thanks to everybody else for moral support and a nice party feeling :-)");
	strcat(scrolltext, "  Greetings to Crusaders, Exile, Trinity and Plsegutta");
	strcat(scrolltext, "                                      ");
	strcat(scrolltext, "  Umm... this is it really, you can press ESC now.");
	strcat(scrolltext, "  Oh, and the source code will be available for download from www.atc.no if you want to have a peek.");

	cube_model = load_model3d("cube.m3d");
	discos_model = load_model3d("discos.m3d");
	cube_object1 = create_object3d(cube_model);
	cube_object2 = create_object3d(cube_model);
	cube_object3 = create_object3d(cube_model);
	cube_object4 = create_object3d(cube_model);
	cube_object5 = create_object3d(cube_model);
	cube_object6 = create_object3d(cube_model);
	cube_object7 = create_object3d(cube_model);
	cube_object8 = create_object3d(cube_model);
	cube_object9 = create_object3d(cube_model);
	cube_object10 = create_object3d(cube_model);
	discos_object1 = create_object3d(discos_model);
	discos_object2 = create_object3d(discos_model);
	discos_object3 = create_object3d(discos_model);
	discos_object4 = create_object3d(discos_model);
	discos_object5 = create_object3d(discos_model);
	discos_object6 = create_object3d(discos_model);
	discos_object7 = create_object3d(discos_model);
	discos_object8 = create_object3d(discos_model);

	// Small hack to make 0 visible with this font using O instead
	font_index[48*2] = font_index[79*2];
	font_index[(48*2)+1] = font_index[(79*2)+1];
	font_size[48] = font_size[79];

	move_object3d(cube_object1,   -500, -500, -500);
	move_object3d(cube_object2,   -500,  500, -500);
	move_object3d(cube_object3,    500,  500, -500);
	move_object3d(cube_object4,    500, -500, -500);
	move_object3d(cube_object5,      0,    0, -500);
	move_object3d(cube_object6,   -500, -500,  500);
	move_object3d(cube_object7,   -500,  500,  500);
	move_object3d(cube_object8,    500,  500,  500);
	move_object3d(cube_object9,    500, -500,  500);
	move_object3d(cube_object10,     0,    0,  500);

	move_object3d(discos_object1, -500,    0, -500);
	move_object3d(discos_object2,  500,    0, -500);
	move_object3d(discos_object3,    0, -500, -500);
	move_object3d(discos_object4,    0,  500, -500);
	move_object3d(discos_object5, -500,    0,  500);
	move_object3d(discos_object6,  500,    0,  500);
	move_object3d(discos_object7,    0, -500,  500);
	move_object3d(discos_object8,    0,  500,  500); 




	while (1)
    {
		// Clear buffer
		buffer = (unsigned int*) pixbuffer1;	// Select output buffer
		fill_buffer(BLACK);

		// Place spline points of path 1
		for (index = 0; index < ctrl_points; index++) {

			upper_pNx[index] = (index * ((WIDTH+200) / (ctrl_points-1))) + ((fast_cos(cycle7*2+(index * 570)) * 100) / CIRCLE) - 100;
			lower_pNx[index] = (index * ((WIDTH+200) / (ctrl_points-1))) + ((fast_sin(cycle6*7+(index * 835)) * 100) / CIRCLE) - 100;

			// Adjust the height of each control point
			if (index % 2) {
				upper_pNy[index] = 140 + ((fast_cos(cycle7*2+(index * 570)) * 120) / CIRCLE);
				lower_pNy[index] = 340 + ((fast_sin(cycle6*7+(index * 835)) * 120) / CIRCLE);
			} else {
				upper_pNy[index] = 140 + ((fast_sin(cycle7*2+(index * 570)) * 120) / CIRCLE);
				lower_pNy[index] = 340 + ((fast_cos(cycle6*7+(index * 835)) * 120) / CIRCLE);
			}
		}

		cycle1 = cycle1 + 53;
		cycle2 = cycle2 + 71;
		cycle3 = cycle3 + 63;
		cycle4 = cycle4 + 13;
		cycle5 = cycle5 + 23;
		cycle6 = cycle6 + 11;
		cycle7 = cycle7 + 13;
		if (cycle1 > 0xFFFFFF00) { cycle1 = 0; }
		if (cycle2 > 0xFFFFFF00) { cycle2 = 0; }
		if (cycle3 > 0xFFFFFF00) { cycle3 = 0; }
		if (cycle4 > 0xFFFFFF00) { cycle4 = 0; }
		if (cycle5 > 0xFFFFFF00) { cycle5 = 0; }
		if (cycle6 > 0xFFFFFF00) { cycle6 = 0; }
		if (cycle7 > 0xFFFFFF00) { cycle7 = 0; }
		
		camera.yaw = cycle4;
		camera.pitch = cycle1/2;


		rotate_object3d(cube_object1, -cycle1, cycle4, cycle3);
		rotate_object3d(cube_object2, cycle2, -cycle3, cycle4);
		rotate_object3d(cube_object3, cycle3, cycle2, -cycle1);
		rotate_object3d(cube_object4, cycle4, cycle1, cycle2);
		rotate_object3d(cube_object5, -cycle1, cycle4, cycle3);
		rotate_object3d(cube_object6, -cycle1, cycle4, cycle3);
		rotate_object3d(cube_object7, cycle2, -cycle3, cycle4);
		rotate_object3d(cube_object8, cycle3, cycle2, -cycle1);
		rotate_object3d(cube_object9, cycle4, cycle1, cycle2);
		rotate_object3d(cube_object10, -cycle1, cycle4, cycle3);
		rotate_object3d(discos_object1, cycle1, -cycle4, cycle3);
		rotate_object3d(discos_object2, cycle2, cycle3, -cycle4);
		rotate_object3d(discos_object3, cycle3, cycle2, cycle1);
		rotate_object3d(discos_object4, -cycle4, cycle1, cycle2);
		rotate_object3d(discos_object5, cycle1, -cycle4, cycle3);
		rotate_object3d(discos_object6, cycle2, cycle3, -cycle4);
		rotate_object3d(discos_object7, cycle3, cycle2, cycle1);
		rotate_object3d(discos_object8, -cycle4, cycle1, cycle2);

//		render_pixels();	// Render vertices only, with depth clipping
		render_depth();		// Render using unshaded filled polygons and depth clipping
//		render_flat();		// Render using unshaded filled polygons
//		render_wireframe();	// Basic perspective, used for debugging
//		render_debug();		// No perspective or other fancy stuff, used for debugging

//		color = WHITE;
//		sprintf(debug, "Model name: %s  Vertices: %i  Surfaces: %i\n", modelname, vertices_in_scene, surfaces_in_scene);
//		plot_string(debug, 1,1);


/*
		color = YELLOW;
		plot_spline(ctrl_points, upper_pNx, upper_pNy, resolution);
		color = GREEN;
		plot_spline(ctrl_points, lower_pNx, lower_pNy, resolution);
*/

		// Render scrolltext into bitmap buffer
		color = YELLOW;
		textminor++;
		cursor_x = 32-textminor;
		cursor_y = 1;
	    buffer = (unsigned int*) pixbuffer2;	// Select output buffer
	    buffer = (unsigned int*) scrollbuf;	// Select output buffer
		plot_char(scrolltext[textmajor]);
		secondletter = cursor_x;
		for (index = 0; index < 40; index++) {
			plot_char(scrolltext[index+textmajor+1]);
		}

		if (secondletter <= 32) { textmajor++; textminor = 0; }
		if (textmajor >= strlen(scrolltext)) { textmajor = 0; }
		



/*
		cycle1++;
		if (cycle1 == (ctrl_points-1) * resolution) { cycle1 = 0; }

		color = YELLOW;
		point = get_splinepoint(ctrl_points, upper_pNx, upper_pNy, resolution, cycle1);
		plot_circle(point->x, point->y, 10);

		color = GREEN;
		point = get_splinepoint(ctrl_points, lower_pNx, lower_pNy, resolution, cycle1);
		plot_circle(point->x, point->y, 10);
*/

		// Draw b-spline scrolltext
		color = CYAN;
		for (textscanner = 0; textscanner < ((ctrl_points-1)*resolution)-1; textscanner++) {

			point = get_splinepoint(ctrl_points, upper_pNx, upper_pNy, resolution, textscanner);
			upperleft.x = point->x;
			upperleft.y = point->y;

			point = get_splinepoint(ctrl_points, lower_pNx, lower_pNy, resolution, textscanner);
			lowerleft.x = point->x;
			lowerleft.y = point->y;

			point = get_splinepoint(ctrl_points, upper_pNx, upper_pNy, resolution, textscanner+1);
			upperright.x = point->x;
			upperright.y = point->y;

			point = get_splinepoint(ctrl_points, lower_pNx, lower_pNy, resolution, textscanner+1);
			lowerright.x = point->x;
			lowerright.y = point->y;

//			color = CYAN;
//			plot_line(upperleft.x, upperleft.y, lowerleft.x, lowerleft.y);

			for (pixel = 0; pixel < 8; pixel++) {
//			    buffer = (unsigned int*) pixbuffer2;	// Select output buffer
			    buffer = (unsigned int*) scrollbuf;	// Select output buffer
				color = buffer[(64+textscanner+((pixel+1)*WIDTH))];
				buffer[(64+textscanner+((pixel+1)*WIDTH))] = 0;	// We will only read this point this once, so clear it now
//				color = CYAN;
				if (color > 0) {

					// Upper left corner of "pixel"
					points_x[0] = (((lowerleft.x * (pixel))/9) + ((upperleft.x * (9-pixel))/9));
					points_y[0] = (((lowerleft.y * (pixel))/9) + ((upperleft.y * (9-pixel))/9));

					points_x[1] = (((lowerleft.x * (pixel+1))/9) + ((upperleft.x * (8-pixel))/9));
					points_y[1] = (((lowerleft.y * (pixel+1))/9) + ((upperleft.y * (8-pixel))/9));

					points_x[2] = (((lowerright.x * (pixel+1))/9) + ((upperright.x * (8-pixel))/9));
					points_y[2] = (((lowerright.y * (pixel+1))/9) + ((upperright.y * (8-pixel))/9));

					points_x[3] = (((lowerright.x * (pixel))/9) + ((upperright.x * (9-pixel))/9));
					points_y[3] = (((lowerright.y * (pixel))/9) + ((upperright.y * (9-pixel))/9));

					left   = 0;
					right  = 0;
					top    = 0;
					bottom = 0;

					for (index = 1; index <= 3; index++) {
						if (points_x[index] > points_x[right])  { right  = index; } 
						if (points_x[index] < points_x[left])   { left   = index; } 
						if (points_y[index] < points_y[top])    { top    = index; } 
						if (points_y[index] > points_y[bottom]) { bottom = index; } 
					}
//					height = points_y[bottom]-points_y[top];
//					width  = points_x[right]-points_x[left];
					area = (points_y[bottom]-points_y[top]) * (points_x[right]-points_x[left]);	// Area of bounding box

					// Now subtract the area not covered by the 'pixel'
					area -= ((points_x[top]-points_x[left]) * (points_y[left]-points_y[top])) /2;	// Upper left corner
					area -= ((points_x[right]-points_x[top]) * (points_y[right]-points_y[top])) /2;	// Upper right corner

//					area = ((points_x[bottom]-points_x[left]) * (points_y[bottom]-points_y[left])) /2;	// Lower left corner
//					area -= ((points_x[right]-points_x[bottom]) * (points_y[bottom]-points_y[right])) /2;	// Lower right corner

					area = (area / 4);
					if (area > 255) { area = 255; }
					sprintf(debug, "%d", area);
					color = area + (area << 16);

					points = 4;
				    buffer = (unsigned int*) pixbuffer1;	// Select output buffer
					fill_polygon(points, points_x, points_y);
//					color = CYAN;
//					plot_string(debug, points_x[0], points_y[0]-10);
//					plot_rectangle(points_x[left], points_y[top], points_x[right], points_y[bottom]);
//					plot_circle(points_x[left], points_y[top], 5);
				}
			}
		}



		// Finally, place our name in a frame
	    buffer = (unsigned int*) pixbuffer1;	// Select output buffer
		color = BLUE;
		fill_rectangle(490,435,630,460);
		color = WHITE;
		plot_rectangle(490,435,630,460);
		plot_string("ano-tech computers\n",500,440);
		plot_string("atc.no\n",588,-1);


		// Copy buffer to screen
        ptc_update(pixbuffer1);

    }

	unload_font();
	shutdown_math3d();

}	// main()




