



// Math primitives - private vars
static int Random_seed = 0x12345;

int fast_random(int limit)
{
	// Calculate a random number from 0 to (limit)
	// Set Random_seed to a random number before first use
	int random_number;
	__asm {
		mov edx,limit
		dec edx
			
		mov eax,Random_seed		// noise = seed;
		shr eax,3				// noise >>= 3;
		xor eax,Random_seed		// noise ^= seed;
		mov ebx,eax				// ebx = carry
		and ebx,1				// carry = noise & 1;
		shr eax,1				// noise >>= 1;
		mov ecx,Random_seed		// ecx = seed
		shr ecx,1				// seed >>= 1;
		shl ebx,30				// carry <<= 30;
		or  ecx,ebx				// seed |= carry;
		mov Random_seed,ecx		// store seed
			
		mov ebx,edx				// ebx = limit
		xor edx,edx
		div ebx					// edx = edx:eax % ebx
		mov random_number,edx
	}
	return(random_number);
}


int rgb_mixed(int rgb1, int rgb2)
{
	// Mix two RGB colors by adding each composite color and dividing by 2
	// This is ofcourse done using shift, not arithmetic division
	// Should be reasonably fast although it's still a bottleneck when
	// used to plot semi-transparent stuff- floyd@atc.no
	int mixed;
	int red;
	int green;
	int blue;
	__asm {
		mov edx,rgb1
		mov ebx,rgb2

		mov red,ebx		// Separate color 2
		and red,0xFF0000
		mov green,ebx								
		and green,0x00FF00
		mov blue,ebx								
		and blue,0x0000FF

		mov ebx,edx
		and ebx,0xFF0000
		add ebx,red
		shr ebx,1
		and ebx,0xFF0000
		mov eax,ebx
				
		mov ebx,edx
		and ebx,0x00FF00
		add ebx,green
		shr ebx,1
		and ebx,0x00FF00
		or eax,ebx

		mov ebx,edx
		and ebx,0x0000FF
		add ebx,blue
		shr ebx,1
		and ebx,0x0000FF
		or  eax,ebx

		mov mixed,eax
	}
	return(mixed);
}


// eof.
